'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactJsonTree = require('react-json-tree');

var _reactJsonTree2 = _interopRequireDefault(_reactJsonTree);

var _getItemString2 = require('./getItemString');

var _getItemString3 = _interopRequireDefault(_getItemString2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ActionTab = function ActionTab(_ref) {
  var action = _ref.action;
  var styling = _ref.styling;
  var base16Theme = _ref.base16Theme;
  var isLightTheme = _ref.isLightTheme;
  var labelRenderer = _ref.labelRenderer;
  return _react2.default.createElement(_reactJsonTree2.default, {
    labelRenderer: labelRenderer,
    theme: {
      extend: base16Theme,
      nestedNodeItemString: function nestedNodeItemString(_ref2, expanded) {
        var style = _ref2.style;
        return {
          style: (0, _extends3.default)({}, style, {
            display: expanded ? 'none' : 'inline'
          })
        };
      }
    },
    data: action,
    getItemString: function getItemString(type, data) {
      return (0, _getItemString3.default)(styling, type, data);
    },
    isLightTheme: isLightTheme,
    hideRoot: true
  });
};

exports.default = ActionTab;